#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sat Nov 28 11:22:52 2020

@author: julia
"""
import os, csv
from Bio import SeqIO

# Obtain a dictionary with all the host accessions classified by genus. 
hosts = []
hosts_by_genus = {}
hosts_path = "../../host_genomes/"
for file in os.listdir(hosts_path):
    hosts.append(file.split(".gbk")[0])
    
for filename in hosts:
    with open(hosts_path+filename+".gbk", "r") as gbk_file:
        for record in SeqIO.parse(gbk_file, "genbank"):
            description = record.description
            if description.startswith("Arthrobacter"):
                if "Arthrobacter" not in hosts_by_genus.keys():
                    hosts_by_genus[str("Arthrobacter")] = []
                hosts_by_genus[str("Arthrobacter")].append(filename)
            if description.startswith("Microbacterium"):
                if "Microbacterium" not in hosts_by_genus.keys():
                    hosts_by_genus[str("Microbacterium")] = []
                hosts_by_genus[str("Microbacterium")].append(filename)
            if description.startswith("Faecalibacterium"):
                if "Faecalibacterium" not in hosts_by_genus.keys():
                    hosts_by_genus[str("Faecalibacterium")] = []
                hosts_by_genus[str("Faecalibacterium")].append(filename)
            if description.startswith("Gordonia"):
                if "Gordonia" not in hosts_by_genus.keys():
                    hosts_by_genus[str("Gordonia")] = []
                hosts_by_genus[str("Gordonia")].append(filename)
            if description.startswith("Lactococcus"):
                if "Lactococcus" not in hosts_by_genus.keys():
                    hosts_by_genus[str("Lactococcus")] = []
                hosts_by_genus[str("Lactococcus")].append(filename)
            if description.startswith("Rhodococcus"):
                if "Rhodococcus" not in hosts_by_genus.keys():
                    hosts_by_genus[str("Rhodococcus")] = []
                hosts_by_genus[str("Rhodococcus")].append(filename)
            if description.startswith("Streptomyces"):
                if "Streptomyces" not in hosts_by_genus.keys():
                    hosts_by_genus[str("Streptomyces")] = []
                hosts_by_genus[str("Streptomyces")].append(filename)


# Obtain the csv files required to obtain the plots with ggplot. 
# Variables to change according to host genus:
results_path = "CUB_lib_NC_018750/output/"
group = "S"

# Name of the final file. Open it and write the column headers.
out_file = "file_for_plot_" + group + ".csv"
with open(out_file, "w+") as csv_outfile:
    csv_outfile.write("cluster,accession,GC,nRCA,CAI,group\n")
    
# Obtain a list of all the files from the CUB analysis output.
results_files = []
for file in os.listdir(results_path):
    results_files.append(file)
    
# Construct the csv files used to obtain the plots. 
for filename in results_files:
    with open(results_path+filename, "r") as csv_file:
        acc = filename.split(".csv")[0]
        for line in csv.reader(csv_file, delimiter=","):
            if len(line[0]) == 0:
                CAI = line[7]
                nRCA = line[8]
        if acc not in hosts:
            with open("Table_S3_update (2).csv", "r") as csv_file2:
                for i in range(1):
                    next(csv_file2)
                for line in csv.reader(csv_file2, delimiter=","):
                    if acc in line[4]:
                        cluster_genus = line[2]
                        GC = line[6]
        else:
            for genus in hosts_by_genus.keys():
                for host in hosts_by_genus[genus]:
                    if acc in host:
                        cluster_genus = genus
            with open("../../host_GC.csv", "r") as csv_file3:
                for line in csv.reader(csv_file3, delimiter=","):
                    if acc in line[0]:
                        GC = line[1]
        with open(out_file, "a+") as csv_outfile:
            csv_outfile.write(cluster_genus+","+acc+","+GC+","+nRCA+","+CAI+","+group+"\n")
