#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Sat Nov 21 13:27:07 2020

@author: julia
"""

import os, shutil
from Bio import SeqIO


# Get phage genomes
# Obtain a list of all the phage genome files locally downloaded.
genomes_path = "/home/julia/Escriptori/genomes"
genomes_files = []
for file in os.listdir(genomes_path):
    genomes_files.append(file)
    
# Obtain a list of all the files that include the list of phages that have to be analyzed.
phages_to_analyze = "/home/julia/Insync/julia.tickles@gmail.com/Google Drive - Shared with me/reanalysis/nRCA/new_analysis/scnRCA_host_reference_datasets/phage_genome_acc_by_host"
phages_files = []
for file in os.listdir(phages_to_analyze):
    phages_files.append(file)
    
# For each file in the phage_files list, open it and read it.
for filename in phages_files:
    with open(phages_to_analyze+"/"+filename, "r") as txt:
    # For each of the lines in the opened file (phage accession), if one of the items in genomes_files list contains the line, copy it in the specified folder.
        for line in txt:
            for genome in genomes_files:
                if line.split("\n")[0] in genome:
                    if genome.endswith(".1.gbk"):
                        continue
                    else:
                        shutil.copy(genomes_path+"/"+genome, "/home/julia/Insync/julia.tickles@gmail.com/Google Drive - Shared with me/reanalysis/nRCA/new_analysis/scnRCA_host_reference_datasets/new_code_and_test/CUB_lib_"+filename.split(".txt")[0]+"/input")


# Get hosts genomes
# Obtain a list of all the host genome files locally downloaded.
genomes_path = "../../host_genomes/"
genomes_files = []
for file in os.listdir(genomes_path):
    genomes_files.append(file)

# For each of the files in the genomes_files list, open it and read it in GenBank format. 
for filename in genomes_files:
    with open(genomes_path+"/"+filename, "r") as gbk_file:
        for record in SeqIO.parse(gbk_file, "genbank"):
            description = record.description
            # If the record description starts with one of the specified host genus, copy the GenBank file in the specified folder. 
            if description.startswith("Arthrobacter"):
                shutil.copy(genomes_path+"/"+filename, "/home/julia/Insync/julia.tickles@gmail.com/Google Drive - Shared with me/reanalysis/nRCA/new_analysis/scnRCA_host_reference_datasets/new_code_and_test/CUB_lib_CP014196/input/")
            if description.startswith("Microbacterium"):
                shutil.copy(genomes_path+"/"+filename, "/home/julia/Insync/julia.tickles@gmail.com/Google Drive - Shared with me/reanalysis/nRCA/new_analysis/scnRCA_host_reference_datasets/new_code_and_test/CUB_lib_CP018762/input/")
            if description.startswith("Faecalibacterium"):
                shutil.copy(genomes_path+"/"+filename, "/home/julia/Insync/julia.tickles@gmail.com/Google Drive - Shared with me/reanalysis/nRCA/new_analysis/scnRCA_host_reference_datasets/new_code_and_test/CUB_lib_CP048437/input/")
            if description.startswith("Gordonia"):
                shutil.copy(genomes_path+"/"+filename, "/home/julia/Insync/julia.tickles@gmail.com/Google Drive - Shared with me/reanalysis/nRCA/new_analysis/scnRCA_host_reference_datasets/new_code_and_test/CUB_lib_CP049836/input/")
            if description.startswith("Lactococcus"):
                shutil.copy(genomes_path+"/"+filename, "/home/julia/Insync/julia.tickles@gmail.com/Google Drive - Shared with me/reanalysis/nRCA/new_analysis/scnRCA_host_reference_datasets/new_code_and_test/CUB_lib_NC_009004/input/")
            if description.startswith("Rhodococcus"):
                shutil.copy(genomes_path+"/"+filename, "/home/julia/Insync/julia.tickles@gmail.com/Google Drive - Shared with me/reanalysis/nRCA/new_analysis/scnRCA_host_reference_datasets/new_code_and_test/CUB_lib_NC_012490/input/")
            if description.startswith("Streptomyces"):
                shutil.copy(genomes_path+"/"+filename, "/home/julia/Insync/julia.tickles@gmail.com/Google Drive - Shared with me/reanalysis/nRCA/new_analysis/scnRCA_host_reference_datasets/new_code_and_test/CUB_lib_NC_018750/input/")

